Unit MLMBR_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLMBR(var NB :Array of Integer; var SUM :Array of Real;
                var X :Array of Real; var ALFA :Array of Real;
                var NALFA :Array of Integer;
                var PALFA :Array of Integer; M :Integer; KV :Integer;
                N :Integer);

implementation

procedure MLMBR(var NB :Array of Integer; var SUM :Array of Real;
                var X :Array of Real; var ALFA :Array of Real;
                var NALFA :Array of Integer;
                var PALFA :Array of Integer; M :Integer; KV :Integer;
                N :Integer);
var
R1,R,R2,R4,R5 :Integer;
R6 :Real;
label
_2,_3,_4,_5,_6,_7,_8;
begin
R1 := M-3;
for R4:=1 to R1 do
 begin
  for R:=1 to R1 do
   begin
    if ( NB[R-1] = 0 )
     then goto _4;
    R2 := R+1;
_2:
    if ( NB[R2-1] <> 0 )
     then goto _3;
    R2 := R2+1;
    if ( R2 > R1 )
     then goto _4;
    goto _2;
_3:
    if ( NB[R-1] < NB[R2-1] ) 
     then goto _4;
    R5 := NB[R-1];
    NB[R-1] := NB[R2-1];
    NB[R2-1] := R5;
    R6 := X[R-1];
    X[R-1] := X[R2-1];
    X[R2-1] := R6;
_4:
   end;
_5:
 end;
for R4:=1 to N do
 begin
_6:
  SUM[R4-1] := 0.0;
 end;
R5 := M-2;
for R4:=1 to R5 do
 begin
  if ( NB[R4-1] = 0 )
   then goto _7;
  R1 := NB[R4-1];
  SUM[R1-1] := X[R4-1];
_7:
 end;
for R4:=1 to KV do
 begin
  if ( PALFA[R4-1] <> 1 )
   then goto _8;
  R1 := NALFA[R4-1];
  SUM[R1-1] := ALFA[R4-1];
_8:
 end;
end;

end.
