Unit MLMPM_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLMPM(var A :Array of Real; var NSA :Array of Integer;
                var NTAB :Array of Integer; var T :Array of Real;
                var PT :Array of Integer; var X :Array of Real;
                var SUM :Array of Real; var NB :Array of Integer;
                M :Integer; N :Integer; P :Integer; var ZM :Integer);

implementation

procedure MLMPM(var A :Array of Real; var NSA :Array of Integer;
                var NTAB :Array of Integer; var T :Array of Real;
                var PT :Array of Integer; var X :Array of Real;
                var SUM :Array of Real; var NB :Array of Integer;
                M :Integer; N :Integer; P :Integer; var ZM :Integer);
var
R,R2,H,F,I :Integer;
R1 :Real;
label
_30,_13,_1,_2,_3,_5,_6,_4,_8;
begin
R := M-2;
for I:=1 to R do
 begin
_30:
  NB[I-1] := 0;
 end;
R := 1;
for I:=1 to N do
 begin
  R2 := NSA[R-1];
  if ( P = 0 ) 
   then goto _13;
  T[I-1] := -T[I-1];
_13:
  if ( NTAB[I-1] <> 1 ) 
   then goto _1;
  if ( A[R-1] <> 1.0 ) 
   then goto _1;
  if ( NB[R2-1] <> 0 ) 
   then goto _1;
  if ( T[I-1] <> 0.0 ) 
   then goto _1;
  NB[R2-1] := I;
  PT[I-1] := 1;
  SUM[I-1] := 0.0;
_1:
  R := R+NTAB[I-1];
_2:
 end;
R := 0;
_3:
for I:=1 to N do
 begin
  R1 := 0.0;
  F := NTAB[I-1];
  if ( PT[I-1] <> 1 ) 
   then goto _5;
  R := R+1;
  goto _4;
_5:
  for H:=1 to F do
   begin
    R := R+1;
    R2 := NSA[R-1];
    if ( NB[R2-1] <> 0 ) 
     then goto _6;
    R1 := A[R-1]+R1;
_6:
   end;
  SUM[I-1] := -R1;
_4:
 end;
R2 := M-2;
X[M-1] := 0.0;
X[M-2] := 0.0;
ZM := 0;
for I:=1 to R2 do
 begin
  if ( NB[I-1] <> 0 ) 
   then goto _8;
  X[M-1] := X[M-1]+X[I-1];
  ZM := 1;
_8:
 end;
X[M-1] := -X[M-1];
end;

end.
