Unit MLMX1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLMX1(TETA :Real; PR17 :Real; PR16 :Integer; PR6 :Integer;
                PR :Integer; M :Integer; var XK :Array of Real;
                L :Integer; var X :Array of Real;
                var RA :Array of Real; PR13 :Real;
                var NB :Array of Integer; K :Integer; var DUR4 :Real;
                DUR5 :Real; var PALFA :Array of Integer;
                var PT :Array of Integer);

implementation

procedure MLMX1(TETA :Real; PR17 :Real; PR16 :Integer; PR6 :Integer;
                PR :Integer; M :Integer; var XK :Array of Real;
                L :Integer; var X :Array of Real;
                var RA :Array of Real; PR13 :Real;
                var NB :Array of Integer; K :Integer; var DUR4 :Real;
                DUR5 :Real; var PALFA :Array of Integer;
                var PT :Array of Integer);
var
R3,R11 :Integer;
label
_5,_2,_6,_3,_1,_4;
begin

{      EPECTBAETC X(I),KOA BBOMA }
{      EPEMEHHA BXOT HA PAHY. }
{      B MACCBE ALFA OMEAETC EPEMEHHA, }
{      BEA HA BEPXH PAHY  CTPAETC }
{      OMETKA  EPEMEHHO,YEE C }
{      BEPXHE PAH. }

R3 := M-2;
if ( TETA <> PR17 )
 then goto _5;
PALFA[PR16-1] := 1;
_5:
if ( PR6 = 0 )
 then goto _6;
PALFA[PR-1] := 0;
for R11:=1 to R3 do
 begin
_2:
  XK[R11-1] := -XK[R11-1];
 end;
DUR4 := -DUR4;
_6:
for R11:=1 to M do
 begin
  RA[R11-1] := -XK[R11-1]/DUR4;
_3:
  X[R11-1] := RA[R11-1]*DUR5+X[R11-1];
 end;
RA[L-1] := 1.0/DUR4;
X[L-1] := RA[L-1]*DUR5;
if ( PR6 = 0 )
 then goto _1;
X[L-1] := X[L-1]+PR13;
_1:
if ( NB[L-1] = 0 )
 then goto _4;
R11 := NB[L-1];
PT[R11-1] := 0;
_4:
NB[L-1] := K;
end;

end.
