Unit MLMXI_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLMXI(var XK :Array of Real; L :Integer;
                var RA :Array of Real; var X :Array of Real;
                M :Integer);

implementation

procedure MLMXI(var XK :Array of Real; L :Integer;
                var RA :Array of Real; var X :Array of Real;
                M :Integer);
var
I,R :Integer;
R1,R2 :Real;
label
_1;
begin

{      BCET HOBY EMEHTAPHY MATPY B }
{      PAOEM MACCBE RA  TEKY AH B X. }

R1 := XK[L-1];
R2 := X[L-1];
for R:=1 to M do
 begin
  RA[R-1] := -(XK[R-1]/R1);
_1:
  X[R-1] := X[R-1]+RA[R-1]*R2;
 end;
RA[L-1] := 1.0/R1;
X[L-1] := RA[L-1]*R2;
end;

end.
