Unit MLMXK2_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLMXK2(var XK :Array of Real; var B :Array of Real;
                var MS :Array of Integer; var MS1 :Array of Integer;
                K1 :Integer; var NTB :Array of Integer);

implementation

procedure MLMXK2(var XK :Array of Real; var B :Array of Real;
                var MS :Array of Integer; var MS1 :Array of Integer;
                K1 :Integer; var NTB :Array of Integer);
var
K3,R1,R2,R3,R4,R6,J :Integer;
R8 :Real;
label
_16,_42,_43,_44,_45;
begin

{      YMHOATC EMEHTAPHE MATP E }
{      HA CTOE XK.PEYTAT CTABTC B }
{      MACCB XK. }

R3 := 0;
R6 := 0;
R2 := 0;
K3 := K1;
if ( K1 <> 0 )
 then goto _44;
goto _16;
_44:
R2 := R2+1;
R6 := R6+R3;
R1 := MS1[R2-1];
R3 := MS[R2-1];
R8 := XK[R1-1];
for J:=1 to R3 do
 begin
  R4 := NTB[R6+J-1];
  if ( R4 = R1 )
   then goto _43;
  XK[R4-1] := B[R6+J-1]*R8+XK[R4-1];
_42:
 end;
_45:
K3 := K3-1;
if ( K3 = 0 )
 then goto _16;
goto _44;
_43:
XK[R1-1] := B[R6+J-1]*R8;
goto _42;
_16:
end;

end.
