Unit MLMD_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLMD(var V :Array of Real; var A :Array of Real;
                var T :Array of Real; M :Integer; N :Integer;
                EPS :Real; var K :Integer; var ALFA :Array of Real;
                KV :Integer; var RA :Array of Real;
                var SUM :Array of Real; var G :Real;
                var PT :Array of Integer; var PALFA :Array of Integer;
                var NSA :Array of Integer; var NTAB :Array of Integer;
                var NALFA :Array of Integer; ZB :Integer);

implementation

procedure MLMD(var V :Array of Real; var A :Array of Real;
                var T :Array of Real; M :Integer; N :Integer;
                EPS :Real; var K :Integer; var ALFA :Array of Real;
                KV :Integer; var RA :Array of Real;
                var SUM :Array of Real; var G :Real;
                var PT :Array of Integer; var PALFA :Array of Integer;
                var NSA :Array of Integer; var NTAB :Array of Integer;
                var NALFA :Array of Integer; ZB :Integer);
var
EL,DY,LB,CS,R,R1,R2,R3,R4,R10,R11,I :Integer;
R5,R6,R8 :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin
R3 := 0;
R8 := EPS;
R := 0;
R11 := 1;
R1 := 0;
_1:
R10 := NALFA[R11-1];
_2:
R := R+1;
R2 := NTAB[R-1];
if ( PT[R-1] = 1 )
 then goto _7;
R6 := V[M-2]*T[R-1];
if ( ZB = 0 )
 then goto _3;
R5 := RA[M-2]*T[R-1];
_3:
for I:=1 to R2 do
 begin
  R3 := R3+1;
  R4 := NSA[R3-1];
  R6 := V[R4-1]*A[R3-1]+R6;
  if ( ZB = 0 )
   then goto _4;
  R5 := RA[R4-1]*A[R3-1]+R5;
_4:
 end;
R6 := V[M-1]*SUM[R-1]+R6;
if ( ZB = 0 )
 then goto _5;
R5 := RA[M-1]*SUM[R-1]+R5;
if ( Abs(R5) > Abs(EPS) )
 then goto _8;
_5:
if ( R10 <> R )
 then goto _6;
if ( PALFA[R11-1] <> 1 )
 then goto _6;
R6 := -R6;
_6:
if ( R6 > EPS )
 then goto _8;
if ( R8 <= R6 )
 then goto _8;
R8 := R6;
K := R;
goto _8;
_7:
R3 := R3+R2;
_8:
if ( R10 <> R )
 then goto _9;
if ( R11 = KV )
 then goto _9;
R11 := R11+1;
goto _1;
_9:
if ( R <> N )
 then goto _2;
G := R8;
end;

end.
