Unit MLML11_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLML11(K :Integer; var ALFA :Array of Real; KV :Integer;
                var PR6 :Integer; var TETA :Real; var PR13 :Real;
                var PR :Integer; var PALFA :Array of Integer;
                var NALFA :Array of Integer);

implementation

procedure MLML11(K :Integer; var ALFA :Array of Real; KV :Integer;
                var PR6 :Integer; var TETA :Real; var PR13 :Real;
                var PR :Integer; var PALFA :Array of Integer;
                var NALFA :Array of Integer);
var
R,R4,PRLOC :Integer;
label
_4,_1,_2,_3;
begin

{      POBEPET,MEET  BBOM CTOE }
{      OPAHEHE,EC BBOM CTOE }
{      EO HOMEP,A B TETA PR13-BEPXHEE }
{      OPAHEHE,EC K-A EPEMEHHA }
{      HAXOTC HA BEPXHE PAHE,TO B }
{      PR6 AHOCTC HOMEP OPAHEHHOO }
{      CTOA,BO BCEX PYX CYAX PR6=0. }

PR13 := 0.0;
TETA := 1.E10;
R := 0;
PR6 := 0;
for PRLOC:=1 to KV do
 begin
  R4 := NALFA[PRLOC-1];
_4:
  if ( K = R4 )
   then goto _2;
_1:
 end;
goto _3;
_2:
PR := PRLOC;
TETA := ALFA[PR-1];
PR13 := ALFA[PR-1];
if ( PALFA[PR-1] <> 1 ) 
 then goto _3;
PR6 := R4;
_3:
end;

end.
