Unit MLMU_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLMU(var B :Array of Real; S :Integer;
                var MS :Array of Integer; var MS1 :Array of Integer;
                K1 :Integer; M :Integer; var V :Array of Real;
                var RA :Array of Real; var NTB :Array of Integer;
                ZM :Integer; ZB :Integer);

implementation

procedure MLMU(var B :Array of Real; S :Integer;
                var MS :Array of Integer; var MS1 :Array of Integer;
                K1 :Integer; M :Integer; var V :Array of Real;
                var RA :Array of Real; var NTB :Array of Integer;
                ZM :Integer; ZB :Integer);
var
J,K3,R,R1,R3,R4 :Integer;
R5,R6 :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9;
begin

{      BCETC U(M) HA I-TAE,U(M-1)-HAII. }

K3 := K1;
R3 := S;
for J:=1 to M do
 begin
_1:
  V[J-1] := 0.0;
 end;
if ( ZM = 0 ) 
 then goto _2;
if ( K1 <> 0 )
 then goto _2;
V[M-1] := 1.0;
goto _9;
_2:
if ( ZM = 0 )
 then goto _3;
if ( ZB = 1 )
 then goto _7;
V[M-1] := 1.0;
goto _4;
_3:
V[M-2] := 1.0;
_4:
if ( K3 = 0 )
 then goto _9;
R := MS1[K3-1];
R1 := MS[K3-1];
R3 := R3-R1;
R5 := 0.0;
for J:=1 to R1 do
 begin
  R4 := NTB[R3+J-1];
  R5 := V[R4-1]*B[R3+J-1]+R5;
  if ( ZB = 0 )
   then goto _5;
  R6 := RA[R4-1]*B[R3+J-1]+R6;
_5:
 end;
V[R-1] := R5;
if ( ZB = 0 )
 then goto _6;
RA[R-1] := R6;
_6:
K3 := K3-1;
goto _4;
_7:
for J:=1 to M do
 begin
_8:
  RA[J-1] := 0.0;
 end;
RA[M-1] := 1.0;
goto _3;
_9:
end;

end.
