Unit MLMVX1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLMVX1(var ALFA :Array of Real; KV :Integer;
                var X :Array of Real; M :Integer;
                var A :Array of Real; var T :Array of Real;
                var SUM :Array of Real; var PT :Array of Integer;
                var PALFA :Array of Integer;
                var NALFA :Array of Integer;
                var NSA :Array of Integer;
                var NTAB :Array of Integer);

implementation

procedure MLMVX1(var ALFA :Array of Real; KV :Integer;
                var X :Array of Real; M :Integer;
                var A :Array of Real; var T :Array of Real;
                var SUM :Array of Real; var PT :Array of Integer;
                var PALFA :Array of Integer;
                var NALFA :Array of Integer;
                var NSA :Array of Integer;
                var NTAB :Array of Integer);
var
R1,R2,R,R5,R3,I,R4 :Integer;
label
_5,_2,_3,_4,_1;
begin

{      EPECTBAET BEKTOP PABX ACTE }

R := 0;
R3 := 0;
for R1:=1 to KV do
 begin
  R2 := NALFA[R1-1];
  if ( PALFA[R1-1] <> 1 )
   then goto _1;
_5:
  R := R+1;
  R5 := NTAB[R-1];
_2:
  if ( R = R2 )
   then goto _3;
  R3 := R5+R3;
  goto _5;
_3:
  for I:=1 to R5 do
   begin
    R3 := R3+1;
    R4 := NSA[R3-1];
    X[R4-1] := X[R4-1]-A[R3-1]*ALFA[R1-1];
_4:
   end;
  X[M-1] := X[M-1]-SUM[R2-1]*ALFA[R1-1];
  X[M-2] := X[M-2]-T[R2-1]*ALFA[R1-1];
_1:
 end;
end;

end.
